import { Highlightable } from "@angular/cdk/a11y";
import { ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, SimpleChanges } from "@angular/core";
import { MenuGroupComponent } from "../menu-group/menu-group.component";
import * as i0 from "@angular/core";
/**
 * @ignore
 */
/**
 * Base class for menu items. Adds styles to host element
 */
export declare abstract class MenuItemBaseComponent implements OnChanges, Highlightable {
    readonly group: MenuGroupComponent;
    private cd;
    /**
     * Disables action, link and option components
     */
    disabled?: boolean;
    setDefaultClass: boolean;
    setDisabledClass: boolean;
    get active(): boolean;
    actionDone: EventEmitter<boolean | undefined>;
    isActive: boolean;
    abstract menuItem: ElementRef;
    constructor(group: MenuGroupComponent, cd: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    setActive(val: boolean): void;
    setActiveStyles(): void;
    setInactiveStyles(): void;
    abstract doAction(event?: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MenuItemBaseComponent, [{ optional: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<MenuItemBaseComponent, never, never, { "disabled": { "alias": "disabled"; "required": false; }; }, { "actionDone": "actionDone"; }, never, never, true, never>;
}
